<?php

  function register_LivelyChatSupport_admin_menu() {
    add_menu_page( "Lively Chat", "Lively Chat", "manage_options", "livelychatsupport", "LivelyChatSupport_admin" );
  }
  
  function LivelyChatSupport_admin() {
    global $wpdb;
  
    wp_register_style( "LivelyChatSupport-admin-css", plugins_url( "lively-chat-support/admin/css/style.css" ) );
    wp_register_style( "LivelyChatSupport-chatbox-reset", plugins_url( "lively-chat-support/chatbox/css/reset.css" ) );
    wp_register_style( "LivelyChatSupport-chatbox-style", plugins_url( "lively-chat-support/chatbox/css/style.css" ) );
    wp_enqueue_style( array("LivelyChatSupport-chatbox-reset", "LivelyChatSupport-chatbox-style", "LivelyChatSupport-chatbox-colours", "LivelyChatSupport-admin-css", "wp-color-picker") );
  
    wp_register_script( "LivelyChatSupport-admin-js", plugins_url( "lively-chat-support/admin/js/admin.js" ) );
    wp_enqueue_script( array("jquery", "jquery-ui", "wp-color-picker", "LivelyChatSupport-admin-js") );
  	wp_enqueue_media();

    if (isset($_POST["subscriber_email"]) && isset($_POST["subscriber_name"])) { LivelyChatSupport_subscribe_to_touchbase("http://touch-base.co/api/contacts", array("name" => $_POST["subscriber_name"], "email" => $_POST["subscriber_email"], "initiated-at" => date("Y-m-d H:i:s"), "initiated" => "LivelyChatSupport")); }
    if (isset($_POST["subscriber_email"])) { update_option("livelychatsupport_email", $_POST["subscriber_email"]); }
    if (isset($_POST["subscriber_name"])) { update_option("livelychatsupport_name", $_POST["subscriber_name"]); }
    if (isset($_POST["online"])) { update_option("livelychatsupport_online", $_POST["online"]); }
    if (isset($_POST["colour"]) && $_POST["colour"] != "") { update_option("livelychatsupport_colour", $_POST["colour"]); }
    if (isset($_POST["position"]) && $_POST["position"] != "") { update_option("livelychatsupport_position", $_POST["position"]); }
    if (isset($_POST["offline_thanks"])) { update_option("livelychatsupport_offline_thanks", $_POST["offline_thanks"]); }
    if (isset($_POST["cta_online_text"]) && $_POST["cta_online_text"] != "") { update_option("livelychatsupport_cta_online_text", $_POST["cta_online_text"]); }
    if (isset($_POST["cta_offline_text"]) && $_POST["cta_offline_text"] != "") { update_option("livelychatsupport_cta_offline_text", $_POST["cta_offline_text"]); }
    if (isset($_POST["cta_online_image"])) { update_option("livelychatsupport_cta_online_image", $_POST["cta_online_image"]); }
    if (isset($_POST["cta_online_image_offset_y"]) && $_POST["cta_online_image_offset_y"] != "") { update_option("livelychatsupport_cta_online_image_offset_y", $_POST["cta_online_image_offset_y"]); }
    if (isset($_POST["cta_online_image_offset_x"]) && $_POST["cta_online_image_offset_x"] != "") { update_option("livelychatsupport_cta_online_image_offset_x", $_POST["cta_online_image_offset_x"]); }
    if (isset($_POST["cta_offline_image"])) { update_option("livelychatsupport_cta_offline_image", $_POST["cta_offline_image"]); }
    if (isset($_POST["cta_offline_image_offset_y"]) && $_POST["cta_offline_image_offset_y"] != "") { update_option("livelychatsupport_cta_offline_image_offset_y", $_POST["cta_offline_image_offset_y"]); }
    if (isset($_POST["cta_offline_image_offset_x"]) && $_POST["cta_offline_image_offset_x"] != "") { update_option("livelychatsupport_cta_offline_image_offset_x", $_POST["cta_offline_image_offset_x"]); }
  
    if (isset($_POST["agents"]))
    {
      foreach ($_POST["agents"] as $agent)
      {
        if ($agent["id"] == "new")
        {
          $wpdb->insert( 
          	$wpdb->prefix . "livelychatsupport_agents", 
            array(
          	  "name" => $agent["name"],
              "avatar_url" => $agent["avatar_url"]
          	)
          );
        }
        else
        {
          $wpdb->update( 
          	$wpdb->prefix . "livelychatsupport_agents", 
            array(
          	  "name" => $agent["name"],
              "avatar_url" => $agent["avatar_url"]
          	),
            array(
              "id" => $agent["id"]
            )
          );
        }
      }
    }
  
    $livelychatsupport = LivelyChatSupport_details();

    echo '<div id="livelychatsupport" class="wrap">';
  
    include_once(LIVELYCHATSUPPORT_ROOT . "/admin/includes/header.php");
  
    if ($livelychatsupport["subscriber_email"] == "" || $livelychatsupport["subscriber_name"] == "") {
      include_once(LIVELYCHATSUPPORT_ROOT . "/admin/tabs/email_required.php");
    } else {
      $_GET["tab"] = isset($_GET["tab"]) ? $_GET["tab"] : "visitors";
      include_once(LIVELYCHATSUPPORT_ROOT . "/admin/tabs/" . $_GET["tab"] . ".php");
    }
  
    echo '</div>';
  }

  function LivelyChatSupport_subscribe_to_touchbase($url, $subscriber){
    global $wpdb;
    
    if ($subscriber["email"] != "" && $subscriber["name"] != "")
    {
      $ch = curl_init($url);
      curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
      curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
      curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query(array("contacts[]" => $subscriber)));
      curl_setopt($ch, CURLOPT_HTTPHEADER, array("Authorization: Token token=mc7Voj9EbYb0Moip9CPLGaCZoLc0vD4Y"));
      $response = curl_exec($ch);
      
      $wpdb->insert( 
      	$wpdb->prefix . "livelychatsupport_agents", 
        array(
      	  "name" => $subscriber["name"],
          "avatar_url" => plugins_url("lively-chat-support/chatbox/assets/ctas/online/chat_bubbles.png")
      	)
      );
    }
  
    update_option("livelychatsupport_email", $subscriber["email"]);
    update_option("livelychatsupport_name", $subscriber["name"]);
  }
  
  function LivelyChatSupport_add_convo() {
    global $wpdb;
    $convo = LivelyChatSupport_convo($_POST["convo_token"]);
    die(json_encode($convo));
  }
  
  function LivelyChatSupport_read_convo() {
    global $wpdb;
    $convo = LivelyChatSupport_convo($_POST["convo_token"]);
    $wpdb->update( 
    	$wpdb->prefix . "livelychatsupport_convos", 
      array(
    	  "pending" => false
    	),
      array(
        "token" => $convo->token
      )
    );
    
    die(json_encode(array("success" => true)));
  }
  
?>